from wasabi import msg

from ._app import app, setup_cli  # noqa: F401

# These are the actual functions, NOT the wrapped CLI commands. The CLI commands
# are registered automatically and won't have to be imported here.
from .download import download  # noqa: F401
from .info import info  # noqa: F401
from .package import package  # noqa: F401
from .profile import profile  # noqa: F401
from .train import train_cli  # noqa: F401
from .pretrain import pretrain  # noqa: F401
from .debug_data import debug_data  # noqa: F401
from .evaluate import evaluate  # noqa: F401
from .convert import convert  # noqa: F401
from .init_model import init_model  # noqa: F401
from .validate import validate  # noqa: F401


@app.command("link", no_args_is_help=True, deprecated=True, hidden=True)
def link(*args, **kwargs):
    """As of spaCy v3.0, model symlinks are deprecated. You can load models
    using their full names or from a directory path."""
    msg.warn(
        "As of spaCy v3.0, model symlinks are deprecated. You can load models "
        "using their full names or from a directory path."
    )
